Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.jboss.netty.handler.codec.http
Class HttpRequestDecoder

    java.lang.Object
      org.jboss.netty.channel.SimpleChannelUpstreamHandler
          org.jboss.netty.handler.codec.replay.ReplayingDecoder<HttpMessageDecoder.State>
              org.jboss.netty.handler.codec.http.HttpMessageDecoder
                  org.jboss.netty.handler.codec.http.HttpRequestDecoder

All Implemented Interfaces:
  ChannelHandler, ChannelUpstreamHandler

    public class HttpRequestDecoder

extends HttpMessageDecoder

Decodes `ChannelBuffer`s into `HttpRequest`s and `HttpChunk`s.

### Parameters that prevents excessive memory consumption

Name | Meaning
--- | ---
`maxInitialLineLength` | The maximum length of the initial line (e.g. `"GET / HTTP/1.0"`) If the length of the initial line exceeds this value, a `TooLongFrameException` will be raised.
`maxHeaderSize` | The maximum length of all headers. If the sum of the length of each header exceeds this value, a `TooLongFrameException` will be raised.
`maxChunkSize` | The maximum length of the content or each chunk. If the content length exceeds this value, the transfer encoding of the decoded request will be converted to 'chunked' and the content will be split into multiple `HttpChunk`s. If the transfer encoding of the HTTP request is 'chunked' already, each chunk will be split into smaller chunks if the length of the chunk exceeds this value. If you prefer not to handle `HttpChunk`s in your handler, insert `HttpChunkAggregator` after this decoder in the `ChannelPipeline`.

Version:
  $Rev: 2095 $, $Date: 2010-01-27 17:13:38 +0900 (Wed, 27 Jan 2010) $
Author:
  The Netty Project, Andy Taylor (andy.taylor@jboss.org), Trustin Lee

Nested Class Summary

Nested classes/interfaces inherited from class org.jboss.netty.handler.codec.http.HttpMessageDecoder
`HttpMessageDecoder.State`

Nested classes/interfaces inherited from interface org.jboss.netty.channel.ChannelHandler
`ChannelHandler.Sharable`

Constructor Summary
`HttpRequestDecoder()` Creates a new instance with the default `maxInitialLineLength (4096`}, `maxHeaderSize (8192)`, and `maxChunkSize (8192)`.
`HttpRequestDecoder(int maxInitialLineLength, int maxHeaderSize, int maxChunkSize)` Creates a new instance with the specified parameters.

Method Summary
`protected HttpMessage` | `createMessage(String[] initialLine)`
`protected boolean` | `isDecodingRequest()`

Methods inherited from class org.jboss.netty.handler.codec.http.HttpMessageDecoder
`decode, isContentAlwaysEmpty`

Methods inherited from class org.jboss.netty.handler.codec.replay.ReplayingDecoder
`actualReadableBytes, channelClosed, channelDisconnected, checkpoint, checkpoint, decodeLast, exceptionCaught, getState, internalBuffer, messageReceived, setState`

Methods inherited from class org.jboss.netty.channel.SimpleChannelUpstreamHandler
`channelBound, channelConnected, channelInterestChanged, channelOpen, channelUnbound, childChannelClosed, childChannelOpen, handleUpstream, writeComplete`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### HttpRequestDecoder

    public HttpRequestDecoder()

  Creates a new instance with the default `maxInitialLineLength (4096`}, `maxHeaderSize (8192)`, and `maxChunkSize (8192)`.

### HttpRequestDecoder

    public HttpRequestDecoder(int maxInitialLineLength,
                              int maxHeaderSize,
                              int maxChunkSize)

  Creates a new instance with the specified parameters.

Method Detail

### createMessage

    protected HttpMessage createMessage(String[] initialLine)
                                 throws Exception

  Specified by:
    `createMessage` in class `HttpMessageDecoder`
  Throws:
    `Exception`

### isDecodingRequest

    protected boolean isDecodingRequest()

  Specified by:
    `isDecodingRequest` in class `HttpMessageDecoder`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2008-2010 JBoss, a division of Red Hat, Inc.. All Rights Reserved.